Subject: [media-types] Update to media type "application/ttml+xml"

From: Philippe Le Hegaret <[email-masked]>
Date: Thu, 16 Jun 2016 10:16:03 -0400

The W3C Timed Text Working Group would like to update the media type 
"application/ttml+xml" as follows. Comments are welcome.

It updates the media type, "application/ttml+xml" to add a new 
parameter, codecs. All other provisions of the media type specification 
remain the same. This supercedes the initial registration information in 
TTML 1.0 Second Edition.

Text copied below but see also the original text at:
  https://www.w3.org/TR/2016/NOTE-ttml-profile-registry-20160510/#mediatype

[[

Type name:

     application
Subtype name:

     ttml+xml
Required parameters:

     None.
Optional parameters:

     charset

         If specified, the charset parameter must match the XML encoding 
declaration, or if absent, the actual encoding. See also Encoding 
Considerations below.
     profile

         The document profile of a TTMLDocument Instance may be 
specified using an optional profile parameter, which, if specified, the 
value of which must adhere to the syntax and semantics of ttp:profile 
parameter defined by TTML 1.0 Second Edition, Section 6.2.8 ttp:profile 
of the published specification.

     codecs

         The optional codecs parameter provides a short form version of 
the profile parameter with multiple-profile combinatorial capability. If 
a short (4-character) form of a profile is registered in the TTML 
Profile Registry, it is recommended that this codecs parameter be used 
and not the profile parameter. The nominal value of this parameter is a 
single 4 character code from the registry.

         Additionally, applications using the entries in the registry 
are encouraged to adopt the following combination syntax:

         Employ two combination operators, '+' (AND) and '|' (OR), which 
may be used to specify, respectively, that multiple processor profiles 
apply (simultaneously) or that any processor profile of a list of 
profiles may apply individually. If both operators are used in a codecs 
value, then the '+' operator has precedence.

         The example: "A+B|C+D|E" states that a TTML processor that 
implements any one of A+B or C+D or E processor profiles satisfies, at 
first order, the requirements to fetch and begin decode/processing of a 
TTML document, where X+Y means that both X and Y processor profiles must 
be supported, and X|Y means that either X or Y processor profile must be 
supported.

         For more information about processor profile combination, see 
TTML2 Profile Combination.

Encoding considerations:

     Same for application/xml, except constrained to either UTF-8 or 
UTF-16. See IETF RFC 3023, XML Media Types, Section 3.2. For the purpose 
of filling out the IANA Application for Media Type 
(http://www.iana.org/cgi-bin/mediatypes.pl), the value binary applies.
Security considerations:

     As with other XML types and as noted in IETF RFC 3023, XML Media 
Types, Section 10, repeated expansion of maliciously constructed XML 
entities can be used to consume large amounts of memory, which may cause 
XML processors in constrained environments to fail.

     In addition, because of the extensibility features for TTML and of 
XML in general, it is possible that "application/ttml+xml" may describe 
content that has security implications beyond those described here. 
However, TTML does not provide for any sort of active or executable 
content, and if the processor follows only the normative semantics of 
the published specification, this content will be outside TTML 
namespaces and may be ignored. Only in the case where the processor 
recognizes and processes the additional content, or where further 
processing of that content is dispatched to other processors, would 
security issues potentially arise. And in that case, they would fall 
outside the domain of this registration document.

     Although not prohibited, there are no expectations that XML 
signatures or encryption would normally be employed.
Interoperability considerations:

     The published specification describes processing semantics that 
dictate behavior that must be followed when dealing with, among other 
things, unrecognized elements and attributes, both in TTML namespaces 
and in other namespaces.

     Because TTML is extensible, conformant "application/ttml+xml" 
processors may expect (and enforce) that content received is well-formed 
XML, but it cannot be guaranteed that the content is valid to a 
particular DTD or Schema or that the processor will recognize all of the 
elements and attributes in the document.
Published specification:

     This media type registration is extracted from the TTML Profile 
Registry.
Applications that use this media type:

     TTML is used in the television industry for the purpose of 
authoring, transcoding and exchanging timed text information and for 
delivering captions, subtitles, and other metadata for television 
material repurposed for the Web or, more generally, the Internet.

     There is partial and full support of TTML in components used by 
several Web browsers plugins, and in a number of caption authoring tools.
Additional information:

     Magic number(s):
     File extension(s):

         .ttml
     Macintosh file type code(s):

         "TTML"
     Fragment identifiers:

         For documents labeled as application/ttml+xml, the fragment 
identifier notation is intended to be used with xml:id attributes, as 
described in section 7.2.1 of the Timed Text Markup Language 1 (TTML1) 
specification.

Person & email address to contact for further information:

     Timed Text Working Group ([email-masked])
Intended usage:

     COMMON
Restrictions on usage:

     None
Author:

     The published specification is a work product of the World Wide Web 
Consortium's Timed Text (TT) Working Group.
Change controller:

     The W3C has change control over this specification.
]]
https://www.w3.org/TR/2016/NOTE-ttml-profile-registry-20160510/#mediatype

Thank you,

Philippe

---

From: "Eric Prud'hommeaux" <[email-masked]>
Date: Thu, 16 Jun 2016 16:07:26 -0400

* Philippe Le Hegaret <[email-masked]> [2016-06-16 10:16-0400]
> It updates the media type, "application/ttml+xml" to add a new parameter,
> codecs. All other provisions of the media type specification remain the
> same. This supercedes the initial registration information in TTML 1.0
> Second Edition.
> 
>         The document profile of a TTMLDocument Instance may be specified
> using an optional profile parameter, which, if specified, the value of which
> must adhere to the syntax and semantics of ttp:profile parameter defined by
> TTML 1.0 Second Edition, Section 6.2.8 ttp:profile of the published
> specification.
> 
>     codecs
> 
>         The optional codecs parameter provides a short form version of the
> profile parameter with multiple-profile combinatorial capability. If a short
> (4-character) form of a profile is registered in the TTML Profile Registry,
> it is recommended that this codecs parameter be used and not the profile
> parameter. The nominal value of this parameter is a single 4 character code
> from the registry.
> 
>         Additionally, applications using the entries in the registry are
> encouraged to adopt the following combination syntax:
> 
>         Employ two combination operators, '+' (AND) and '|' (OR), which may
> be used to specify, respectively, that multiple processor profiles apply
> (simultaneously) or that any processor profile of a list of profiles may
> apply individually. If both operators are used in a codecs value, then the
> '+' operator has precedence.
> 
> implements any one of A+B or C+D or E processor profiles satisfies, at first
> order, the requirements to fetch and begin decode/processing of a TTML

PLH indicated that "at first order" is something like an initial claim
about the embedded codecs. Is it the intention that there be some sort
of recovery if that initial claim is incorrect? What should the
processor do if the advertised codec is ogg and the actual codec is
xvid? If you strike "at first order", I think you could avoid having
to define the behavior in the event of invalid parameters.

> document, where X+Y means that both X and Y processor profiles must be
> supported, and X|Y means that either X or Y processor profile must be
> supported.
> 
>         For more information about processor profile combination, see TTML2
> Profile Combination.

  "TTML2 Profile Comination" has no URL in the reg. The hyptertext version links to
    https://www.w3.org/TR/ttml2/#profile-attribute-processorProfileCombination
  propose instead link to
    https://www.w3.org/TR/ttml2/#processor-profile-combination-table
  and embedding that link in ()s in the text.

> Encoding considerations:
> 
>     Same for application/xml, except constrained to either UTF-8 or UTF-16.
> See IETF RFC 3023, XML Media Types, Section 3.2. For the purpose of filling
> out the IANA Application for Media Type
>     As with other XML types and as noted in IETF RFC 3023, XML Media Types,
> Section 10, repeated expansion of maliciously constructed XML entities can
> be used to consume large amounts of memory, which may cause XML processors
> in constrained environments to fail.
> 
>     In addition, because of the extensibility features for TTML and of XML
> in general, it is possible that "application/ttml+xml" may describe content
> that has security implications beyond those described here. However, TTML
> does not provide for any sort of active or executable content, and if the
> processor follows only the normative semantics of the published
> specification, this content will be outside TTML namespaces and may be
> ignored. Only in the case where the processor recognizes and processes the
> additional content, or where further processing of that content is
> dispatched to other processors, would security issues potentially arise. And
> in that case, they would fall outside the domain of this registration
> document.
> 
>     Although not prohibited, there are no expectations that XML signatures
> or encryption would normally be employed.
>     The published specification describes processing semantics that dictate
> behavior that must be followed when dealing with, among other things,
> unrecognized elements and attributes, both in TTML namespaces and in other
> namespaces.
> 
>     Because TTML is extensible, conformant "application/ttml+xml" processors
> may expect (and enforce) that content received is well-formed XML, but it
> cannot be guaranteed that the content is valid to a particular DTD or Schema
> or that the processor will recognize all of the elements and attributes in
> the document.
> Published specification:
> 
>     TTML is used in the television industry for the purpose of authoring,
> transcoding and exchanging timed text information and for delivering
> captions, subtitles, and other metadata for television material repurposed
> for the Web or, more generally, the Internet.
> 
>     There is partial and full support of TTML in components used by several
> Web browsers plugins, and in a number of caption authoring tools.
> Additional information:
> 
>     Magic number(s):
>     File extension(s):
> 
>         .ttml
> _______________________________________________
> media-types mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/media-types

-- 
-ericP

office: +1.617.599.3509
mobile: +33.6.80.80.35.59

([email-masked])
Feel free to forward this message to any list for any purpose other than
email address distribution.

There are subtle nuances encoded in font variation and clever layout
which can only be seen by printing this message on high-clay paper.

---

From: Paul Libbrecht <[email-masked]>
Date: Fri, 17 Jun 2016 18:08:35 +0200

Dear Philippe,

I could not find a complete information but it looks like TTML is a
format that could be contained in a clipboard. E.g. when transporting a
(piece of a) transcript from one document to another. Could I, thus,
suggest that you add below the Macintosh File type and such extra
information two fields:
- Windows clipboard flavour:
- MacOS uniform type identifier:
In order to find the right clipboard type names, a little bit of
research should be done on the existing practice.
Which tools exist out there which can accept or produce TTML?

thanks in advance.

Paul
> Philippe Le Hegaret <mailto:[email-masked]>
> 16 June 2016 at 16:16
> parameter, codecs. All other provisions of the media type
> specification remain the same. This supercedes the initial
> registration information in TTML 1.0 Second Edition.
>
>         If specified, the charset parameter must match the XML
> encoding declaration, or if absent, the actual encoding. See also
> Encoding Considerations below.
>     profile
>
> specified using an optional profile parameter, which, if specified,
> the value of which must adhere to the syntax and semantics of
> ttp:profile parameter defined by TTML 1.0 Second Edition, Section
> 6.2.8 ttp:profile of the published specification.
>
>     codecs
>
> the profile parameter with multiple-profile combinatorial capability.
> If a short (4-character) form of a profile is registered in the TTML
> and not the profile parameter. The nominal value of this parameter is
> a single 4 character code from the registry.
>
>         Employ two combination operators, '+' (AND) and '|' (OR),
> which may be used to specify, respectively, that multiple processor
> profiles apply (simultaneously) or that any processor profile of a
> list of profiles may apply individually. If both operators are used in
> a codecs value, then the '+' operator has precedence.
>
> first order, the requirements to fetch and begin decode/processing of
> a TTML document, where X+Y means that both X and Y processor profiles
> must be supported, and X|Y means that either X or Y processor profile
> must be supported.
>
> UTF-16. See IETF RFC 3023, XML Media Types, Section 3.2. For the
> purpose of filling out the IANA Application for Media Type
> entities can be used to consume large amounts of memory, which may
> cause XML processors in constrained environments to fail.
>
> XML in general, it is possible that "application/ttml+xml" may
> describe content that has security implications beyond those described
> here. However, TTML does not provide for any sort of active or
> executable content, and if the processor follows only the normative
> semantics of the published specification, this content will be outside
> TTML namespaces and may be ignored. Only in the case where the
> processor recognizes and processes the additional content, or where
> further processing of that content is dispatched to other processors,
> would security issues potentially arise. And in that case, they would
> fall outside the domain of this registration document.
>
> processors may expect (and enforce) that content received is
> well-formed XML, but it cannot be guaranteed that the content is valid
> to a particular DTD or Schema or that the processor will recognize all
> of the elements and attributes in the document.
> Published specification:
>
>     The published specification is a work product of the World Wide
> Web Consortium's Timed Text (TT) Working Group.
> Change controller:
>

---

From: Michael Dolan <[email-masked]>
Date: Fri, 17 Jun 2016 23:57:08 +0000

Hi Eric-

Thanks. I think I agree with your comment about "first order". It's either right or it isn't.  And what a robust decoder may wish to do if it detects that it is wrong (and also figures out what it really is) should be out of scope.

I'm not sure I follow your comment about the URL. TTML2 Table 6-3 needs the text that precedes it to understand it.  Maybe I don't understand your comment.

Thanks,
	Mike

-----Original Message-----
From: Eric Prud'hommeaux [mailto:[email-masked]] 
Sent: Thursday, June 16, 2016 1:07 PM
To: Michael Dolan <[email-masked]>
Cc: [email-masked]; Timed Text Working Group <[email-masked]>; Philippe Le Hegaret <[email-masked]>
Subject: Re: [media-types] Update to media type "application/ttml+xml"

> If a short
> (4-character) form of a profile is registered in the TTML Profile 
> Registry, it is recommended that this codecs parameter be used and not 
> the profile parameter. The nominal value of this parameter is a single 
> 4 character code from the registry.
> 
> profiles apply
> (simultaneously) or that any processor profile of a list of profiles 
> may apply individually. If both operators are used in a codecs value, 
> then the '+' operator has precedence.
> 
> a TTML

PLH indicated that "at first order" is something like an initial claim about the embedded codecs. Is it the intention that there be some sort of recovery if that initial claim is incorrect? What should the processor do if the advertised codec is ogg and the actual codec is xvid? If you strike "at first order", I think you could avoid having to define the behavior in the event of invalid parameters.

> See IETF RFC 3023, XML Media Types, Section 3.2. For the purpose of 
> filling out the IANA Application for Media Type 
>     Timed Text Working Group ([email-masked]) Intended usage:
> 
>     COMMON
> Restrictions on usage:
> 
>     None
> Author:
> 

--
-ericP

office: +1.617.599.3509

([email-masked])
Feel free to forward this message to any list for any purpose other than email address distribution.

There are subtle nuances encoded in font variation and clever layout which can only be seen by printing this message on high-clay paper.

---

From: "Eric Prud'hommeaux" <[email-masked]>
Date: Sun, 19 Jun 2016 16:00:55 -0400

* Michael Dolan <[email-masked]> [2016-06-17 23:57+0000]
> I'm not sure I follow your comment about the URL. TTML2 Table 6-3 needs the text that precedes it to understand it.  Maybe I don't understand your comment.

Boring editorial point that you should include the link in visible
text so it shows up in the registration. Otherwise the test/plain reg
just says "see TTML2 Profile Combination" without a link.

I get your point about referencing the previous paragraph rather than
just the table labeled "TTML2 Profile Combination".

-- 
-ericP

office: +1.617.599.3509

([email-masked])

---

From: "Michael Dolan" <[email-masked]>
Date: Tue, 21 Jun 2016 09:20:45 -0700

Hi Paul-

Thanks. FYI, we're mainly focused on the addition of the codecs parameter.
The rest of the text remains unchanged from the prior registration in TTML1.

Maybe one of the tools vendors on the reflector knows of specific details to
propose?

                Mike

                (Note editor)

From: Paul Libbrecht [mailto:[email-masked]] 
Sent: Friday, June 17, 2016 9:09 AM
To: Philippe Le Hegaret <[email-masked]>
Cc: [email-masked]; Timed Text Working Group <[email-masked]>;
'Michael Dolan' <[email-masked]>
Subject: Re: [media-types] Update to media type "application/ttml+xml"

Dear Philippe,

I could not find a complete information but it looks like TTML is a format
that could be contained in a clipboard. E.g. when transporting a (piece of
a) transcript from one document to another. Could I, thus, suggest that you
add below the Macintosh File type and such extra information two fields:
- Windows clipboard flavour:
- MacOS uniform type identifier:
In order to find the right clipboard type names, a little bit of research
should be done on the existing practice.
Which tools exist out there which can accept or produce TTML?

thanks in advance.

Paul

 <mailto:[email-masked]> Philippe Le Hegaret

16 June 2016 at 16:16

[[ 

Type name: 

    application 
Subtype name: 

    ttml+xml 
Required parameters: 

    None. 
Optional parameters: 

    charset 

    codecs 

Encoding considerations: 

    Magic number(s): 
    File extension(s): 

        .ttml 

        "TTML" 
    Fragment identifiers: 

    Timed Text Working Group ([email-masked] <mailto:[email-masked]> ) 
Intended usage: 

    COMMON 
Restrictions on usage: 

    None 
Author: 

Thank you, 

Philippe 

_______________________________________________ 
media-types mailing list 
[email-masked] <mailto:[email-masked]>  
https://www.ietf.org/mailman/listinfo/media-types